Ruby trunk - Bug #634

Time parsing works in 1.8 but not 1.9
10/11/2008 12:02 PM - tenderlovemaking (Aaron Patterson)

Status: Rejected

Priority: Normal

Assignee:

Target version: 1.9.1 Release Candidate

ruby -v: Backport:
Description

=begin

This works in 1.8, but results in "ArgumentError: argument out of range" in 1.9:
require 'time'

Time::parse('06/21/95 04:24:34 PM')

=end

History

#1 - 10/29/2008 01:21 PM - rogerdpack (Roger Pack)

=begin

seems that Date is similarly broken on 1.9, working on 1.8

require 'date’
Date::parse('06/21/95")

~ ruby19 test.rb

/Users/rogerpack/dev/ruby_19_installed/lib/ruby/1.9.0/date.rb:1022:in new_by_frags": invalid date (ArgumentError)

from /Users/rogerpack/dev/ruby_19_installed/lib/ruby/1.9.0/date.rb:1066:inparse’

from test.rb:2:in
=end

#2 - 11/29/2008 04:20 PM - ko1 (Koichi Sasada)
- Assignee set to matz (Yukihiro Matsumoto)
=begin

=end

#3 - 12/11/2008 12:33 PM - yugui (Yuki Sonoda)
- Target version set to 1.9.1 Release Candidate
=begin

=end

#4 - 12/21/2008 12:09 AM - yugui (Yuki Sonoda)
- Due date set to 12/24/2008

- Assignee deleted (matz (Yukihiro Matsumoto))
=begin

=end

#5 - 12/21/2008 02:21 PM - tadf (tadayoshi funaba)

=begin
This is an intentional change (r12859).

=end
https://bugs.ruby-lang.org/projects/ruby-trunk/repository/trunk/revisions/12859

#6 - 12/21/2008 02:34 PM - yugui (Yuki Sonoda)
=begin
On 12/21/08 2:13 PM, tadayoshi funaba wrote:

This is an intentional change (r12859).

Can | regard this issue as rejected?

Yugui yugui@yugui.jp
http://yugui.jp

=end

#7 - 12/21/2008 02:42 PM - tadf (tadayoshi funaba)
=begin
yes, at least this is not a bug, i think.

=end

#8 - 12/21/2008 11:03 PM - yugui (Yuki Sonoda)
- Status changed from Open to Rejected

=begin

=end

#9 - 12/22/2008 04:45 PM - rogerdpack (Roger Pack)
=begin

This is an intentional change (r12859).
Can | regard this issue as rejected?

Seems somewhat surprising to me that
Date::parse('06/21/95")

doesn't parse, though | suppose that's better than what 1.8.x currently does:
irb(main):004:0> Date.parse("08/21/97").to_s
=>"0097-08-21"

Which is definitely bad :)
Should | file these as feature requests to have them work [and guess century].

Also should | file a feature request to change Time.parse to raise on
failed parse instead of returning Time.now [as you can't currently
determine if a time parsed successfully or not--at least not easily].

Thanks!

=end

#10 - 12/22/2008 09:50 PM - matz (Yukihiro Matsumoto)
=begin

In message "Re: [ruby-core:20779] Re: [Bug #634] Time parsing works in 1.8 but not 1.9"
on Mon, 22 Dec 2008 16:36:53 +0900, "Roger Pack" rogerpack2005@gmail.com writes:
|

|>> This is an intentional change (r12859).

|>

|> Can | regard this issue as rejected?

|

|Seems somewhat surprising to me that

|Date::parse('06/21/95'")
|doesn't parse, though | suppose that's better than what 1.8.x currently does:

lirb(main):004:0> Date.parse("08/21/97").to_s
|=>"0097-08-21"

|

|Which is definitely bad :)

"dd/dd/dd" format itself is very culture dependent and ambiguous. It

is yy/mm/dd in Japan (and other countries), mm/dd/yy in USA, dd/mm/yy
in European countries, right? In some cases, you can tell them by
accident, but we should not rely on luck in general cases. | believe

that is the reason parsing this format is disabled in 1.9.

|Also should | file a feature request to change Time.parse to raise on

[failed parse instead of returning Time.now [as you can't currently

|determine if a time parsed successfully or not--at least not easily].

It seems reasonable. You can file a feature request for this issue.
matz.

=end

#11 - 04/15/2009 11:36 AM - rogerdpack (Roger Pack)

=begin
should Date.parse("4/30/2009")
parse in 1.9?

Date.parse("4/30/2009")
ArgumentError: invalid date

Thanks!
=end
